#include <stdio.h>
#include <avr\io.h>
#include <avr\interrupt.h>

void delay_ms(uint16_t x);

void initTimer()
{
	// mode: CTC prescaler: 1024
	TCCR1A  &= (~1<<WGM10);
	TCCR1A  &= (~1<<WGM11);
	TCCR1B  &= (~1<<WGM13);
	TCCR1B  |= 1<<WGM12;
	// prescaler
	TCCR1B  |= 1<<CS10;
	TCCR1B  &=(~ 1<<CS11);
	TCCR1B  |= 1<<CS12;

	// configurati timer-ul pentru 1 secunda
	OCR1A=16000;
	//activati intreruperea
	TIMSK |=1<<OCIE1A;
	
}
int sec5=0;
char start = 0;
char hit = 0;
void run_command(char hit){
    PORTB ^= (1<<2);;
	// stabileste comanda in functie de numarul de hituri
	if(hit == 1)
		PORTC &= ~(1<<4); // fata
	else if(hit == 2)
		PORTC &= ~(1<<6); // spate
	else if(hit == 3){
		PORTC &= ~(1<<4); // fata dreapta
		PORTC &= ~0x01;
	}
	else if(hit == 4){
		PORTC &= ~(1<<4); // fata stanga
		PORTC &= ~(1<<2);
	}
	else if(hit == 5){
		PORTC &= ~(1<<6); //spate stanga
		PORTC &= ~0x01;
	}
	else if(hit == 6){
		PORTC &= ~(1<<6); //spate dreapta
		PORTC &= ~(1<<2);
	}
	int j;
	PORTB &= ~0x01;
	// ruleaza comanda o perioada
	for(j=0;j<13;j++)
			delay_ms(1000);
	//	
	// reseteaza tot masina se opreste
	PORTC |= 0xFF;
	hit=0;
	start = 0;
	PORTB ^= (1<<2);;

}
ISR(TIMER1_COMPA_vect)
{
	//PORTB ^= 0x01;
	sec5=(sec5+1)%20;
	if((start == 1)&&(sec5==19)){
			
			start = 2;
			run_command(hit);
	}
	
}


//functia de delay
void delay_ms(uint16_t x)
{
  uint8_t y, z;
  for ( ; x > 0 ; x--)
  {
    for ( y = 0 ; y < 90 ; y++)
	{
      for ( z = 0 ; z < 6 ; z++)
	  {
        asm volatile ("nop");
      }
    }
  }
}


// initializarea convertorului analog digital
void ADC_init()
{

	DDRA=0; //input

	ADMUX |= (1<<REFS0); // AVCC cu condesnator extern la pinul AREF
	//ADMUX |= (1<<ADLAR); //setarea ordinii bitilor rezultatului conversiei (left-adjusted)
	
	ADCSRA |= (1<<ADEN); // activare ADC
	//ADCSRA |= (1<<ADIE); //activare intreruperi
	
	ADCSRA |= (1<<ADPS0);
	ADCSRA |= (1<<ADPS1); //prescaler la 128
	ADCSRA |= (1<<ADPS2);

}
 



// preluare valoare ADC
uint16_t get_adc() {

	uint16_t value;

	// warm up the ADC, discard the first conversion
	ADCSRA |= (1 << ADSC);
	while (ADCSRA & (1 << ADSC)); 
	value = ADCW;
	
	ADCSRA |= (1 << ADSC);				// start single conversion
	while (ADCSRA & (1 << ADSC)); 		// wait until conversion is done

	return ADC;
}



int main() {

   TIMSK = 0;
	sei();
 
	DDRB = 0x01;
	DDRC = 0xFF;
	
	ADMUX |= 7;
	
	initTimer();
    ADC_init();
    
   int j;
	PORTB |= 0x01;
	PORTC |= 0xFF;

	// 5  1 
   while(1) 
   { 
      
      if (get_adc() > 300) 
      { 
		if(start == 0){
			sec5 = 0;
			hit = 0;
			start = 1;
		}
		hit++;
		
		PORTB &= ~0x01;
        for(j=0;j<10;j++)
			delay_ms(1000);
			
		
		
      } 
	  else{
			PORTB |= 0x01;
	  }
	
   } 

    return 0;
}
